// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use crate::ffi;
use glib::{prelude::*, translate::*};

#[derive(Debug, Eq, PartialEq, Ord, PartialOrd, Hash, Clone, Copy)]
#[non_exhaustive]
#[doc(alias = "TrackerNotifierEventType")]
pub enum NotifierEventType {
    #[doc(alias = "TRACKER_NOTIFIER_EVENT_CREATE")]
    Create,
    #[doc(alias = "TRACKER_NOTIFIER_EVENT_DELETE")]
    Delete,
    #[doc(alias = "TRACKER_NOTIFIER_EVENT_UPDATE")]
    Update,
    #[doc(hidden)]
    __Unknown(i32),
}

#[doc(hidden)]
impl IntoGlib for NotifierEventType {
    type GlibType = ffi::TrackerNotifierEventType;

    #[inline]
    fn into_glib(self) -> ffi::TrackerNotifierEventType {
        match self {
            Self::Create => ffi::TRACKER_NOTIFIER_EVENT_CREATE,
            Self::Delete => ffi::TRACKER_NOTIFIER_EVENT_DELETE,
            Self::Update => ffi::TRACKER_NOTIFIER_EVENT_UPDATE,
            Self::__Unknown(value) => value,
        }
    }
}

#[doc(hidden)]
impl FromGlib<ffi::TrackerNotifierEventType> for NotifierEventType {
    #[inline]
    unsafe fn from_glib(value: ffi::TrackerNotifierEventType) -> Self {
        skip_assert_initialized!();

        match value {
            ffi::TRACKER_NOTIFIER_EVENT_CREATE => Self::Create,
            ffi::TRACKER_NOTIFIER_EVENT_DELETE => Self::Delete,
            ffi::TRACKER_NOTIFIER_EVENT_UPDATE => Self::Update,
            value => Self::__Unknown(value),
        }
    }
}

#[derive(Debug, Eq, PartialEq, Ord, PartialOrd, Hash, Clone, Copy)]
#[non_exhaustive]
#[doc(alias = "TrackerSparqlError")]
pub enum SparqlError {
    #[doc(alias = "TRACKER_SPARQL_ERROR_CONSTRAINT")]
    Constraint,
    #[doc(alias = "TRACKER_SPARQL_ERROR_INTERNAL")]
    Internal,
    #[doc(alias = "TRACKER_SPARQL_ERROR_NO_SPACE")]
    NoSpace,
    #[doc(alias = "TRACKER_SPARQL_ERROR_ONTOLOGY_NOT_FOUND")]
    OntologyNotFound,
    #[doc(alias = "TRACKER_SPARQL_ERROR_OPEN_ERROR")]
    OpenError,
    #[doc(alias = "TRACKER_SPARQL_ERROR_PARSE")]
    Parse,
    #[doc(alias = "TRACKER_SPARQL_ERROR_QUERY_FAILED")]
    QueryFailed,
    #[doc(alias = "TRACKER_SPARQL_ERROR_TYPE")]
    Type,
    #[doc(alias = "TRACKER_SPARQL_ERROR_UNKNOWN_CLASS")]
    UnknownClass,
    #[doc(alias = "TRACKER_SPARQL_ERROR_UNKNOWN_GRAPH")]
    UnknownGraph,
    #[doc(alias = "TRACKER_SPARQL_ERROR_UNKNOWN_PROPERTY")]
    UnknownProperty,
    #[doc(alias = "TRACKER_SPARQL_ERROR_UNSUPPORTED")]
    Unsupported,
    #[doc(alias = "TRACKER_SPARQL_ERROR_MISSING_LAST_MODIFIED_HEADER")]
    MissingLastModifiedHeader,
    #[doc(alias = "TRACKER_SPARQL_ERROR_INCOMPLETE_PROPERTY_DEFINITION")]
    IncompletePropertyDefinition,
    #[doc(alias = "TRACKER_SPARQL_ERROR_CORRUPT")]
    Corrupt,
    #[doc(alias = "TRACKER_SPARQL_ERROR_LAST")]
    Last,
    #[doc(hidden)]
    __Unknown(i32),
}

#[doc(hidden)]
impl IntoGlib for SparqlError {
    type GlibType = ffi::TrackerSparqlError;

    fn into_glib(self) -> ffi::TrackerSparqlError {
        match self {
            Self::Constraint => ffi::TRACKER_SPARQL_ERROR_CONSTRAINT,
            Self::Internal => ffi::TRACKER_SPARQL_ERROR_INTERNAL,
            Self::NoSpace => ffi::TRACKER_SPARQL_ERROR_NO_SPACE,
            Self::OntologyNotFound => ffi::TRACKER_SPARQL_ERROR_ONTOLOGY_NOT_FOUND,
            Self::OpenError => ffi::TRACKER_SPARQL_ERROR_OPEN_ERROR,
            Self::Parse => ffi::TRACKER_SPARQL_ERROR_PARSE,
            Self::QueryFailed => ffi::TRACKER_SPARQL_ERROR_QUERY_FAILED,
            Self::Type => ffi::TRACKER_SPARQL_ERROR_TYPE,
            Self::UnknownClass => ffi::TRACKER_SPARQL_ERROR_UNKNOWN_CLASS,
            Self::UnknownGraph => ffi::TRACKER_SPARQL_ERROR_UNKNOWN_GRAPH,
            Self::UnknownProperty => ffi::TRACKER_SPARQL_ERROR_UNKNOWN_PROPERTY,
            Self::Unsupported => ffi::TRACKER_SPARQL_ERROR_UNSUPPORTED,
            Self::MissingLastModifiedHeader => {
                ffi::TRACKER_SPARQL_ERROR_MISSING_LAST_MODIFIED_HEADER
            }
            Self::IncompletePropertyDefinition => {
                ffi::TRACKER_SPARQL_ERROR_INCOMPLETE_PROPERTY_DEFINITION
            }
            Self::Corrupt => ffi::TRACKER_SPARQL_ERROR_CORRUPT,
            Self::Last => ffi::TRACKER_SPARQL_ERROR_LAST,
            Self::__Unknown(value) => value,
        }
    }
}

#[doc(hidden)]
impl FromGlib<ffi::TrackerSparqlError> for SparqlError {
    unsafe fn from_glib(value: ffi::TrackerSparqlError) -> Self {
        skip_assert_initialized!();

        match value {
            ffi::TRACKER_SPARQL_ERROR_CONSTRAINT => Self::Constraint,
            ffi::TRACKER_SPARQL_ERROR_INTERNAL => Self::Internal,
            ffi::TRACKER_SPARQL_ERROR_NO_SPACE => Self::NoSpace,
            ffi::TRACKER_SPARQL_ERROR_ONTOLOGY_NOT_FOUND => Self::OntologyNotFound,
            ffi::TRACKER_SPARQL_ERROR_OPEN_ERROR => Self::OpenError,
            ffi::TRACKER_SPARQL_ERROR_PARSE => Self::Parse,
            ffi::TRACKER_SPARQL_ERROR_QUERY_FAILED => Self::QueryFailed,
            ffi::TRACKER_SPARQL_ERROR_TYPE => Self::Type,
            ffi::TRACKER_SPARQL_ERROR_UNKNOWN_CLASS => Self::UnknownClass,
            ffi::TRACKER_SPARQL_ERROR_UNKNOWN_GRAPH => Self::UnknownGraph,
            ffi::TRACKER_SPARQL_ERROR_UNKNOWN_PROPERTY => Self::UnknownProperty,
            ffi::TRACKER_SPARQL_ERROR_UNSUPPORTED => Self::Unsupported,
            ffi::TRACKER_SPARQL_ERROR_MISSING_LAST_MODIFIED_HEADER => {
                Self::MissingLastModifiedHeader
            }
            ffi::TRACKER_SPARQL_ERROR_INCOMPLETE_PROPERTY_DEFINITION => {
                Self::IncompletePropertyDefinition
            }
            ffi::TRACKER_SPARQL_ERROR_CORRUPT => Self::Corrupt,
            ffi::TRACKER_SPARQL_ERROR_LAST => Self::Last,
            value => Self::__Unknown(value),
        }
    }
}

impl glib::error::ErrorDomain for SparqlError {
    #[inline]
    fn domain() -> glib::Quark {
        skip_assert_initialized!();

        unsafe { from_glib(ffi::tracker_sparql_error_quark()) }
    }

    #[inline]
    fn code(self) -> i32 {
        self.into_glib()
    }

    #[inline]
    #[allow(clippy::match_single_binding)]
    fn from(code: i32) -> Option<Self> {
        skip_assert_initialized!();
        match unsafe { from_glib(code) } {
            value => Some(value),
        }
    }
}

#[derive(Debug, Eq, PartialEq, Ord, PartialOrd, Hash, Clone, Copy)]
#[non_exhaustive]
#[doc(alias = "TrackerSparqlValueType")]
pub enum SparqlValueType {
    #[doc(alias = "TRACKER_SPARQL_VALUE_TYPE_UNBOUND")]
    Unbound,
    #[doc(alias = "TRACKER_SPARQL_VALUE_TYPE_URI")]
    Uri,
    #[doc(alias = "TRACKER_SPARQL_VALUE_TYPE_STRING")]
    String,
    #[doc(alias = "TRACKER_SPARQL_VALUE_TYPE_INTEGER")]
    Integer,
    #[doc(alias = "TRACKER_SPARQL_VALUE_TYPE_DOUBLE")]
    Double,
    #[doc(alias = "TRACKER_SPARQL_VALUE_TYPE_DATETIME")]
    Datetime,
    #[doc(alias = "TRACKER_SPARQL_VALUE_TYPE_BLANK_NODE")]
    BlankNode,
    #[doc(alias = "TRACKER_SPARQL_VALUE_TYPE_BOOLEAN")]
    Boolean,
    #[doc(hidden)]
    __Unknown(i32),
}

#[doc(hidden)]
impl IntoGlib for SparqlValueType {
    type GlibType = ffi::TrackerSparqlValueType;

    #[inline]
    fn into_glib(self) -> ffi::TrackerSparqlValueType {
        match self {
            Self::Unbound => ffi::TRACKER_SPARQL_VALUE_TYPE_UNBOUND,
            Self::Uri => ffi::TRACKER_SPARQL_VALUE_TYPE_URI,
            Self::String => ffi::TRACKER_SPARQL_VALUE_TYPE_STRING,
            Self::Integer => ffi::TRACKER_SPARQL_VALUE_TYPE_INTEGER,
            Self::Double => ffi::TRACKER_SPARQL_VALUE_TYPE_DOUBLE,
            Self::Datetime => ffi::TRACKER_SPARQL_VALUE_TYPE_DATETIME,
            Self::BlankNode => ffi::TRACKER_SPARQL_VALUE_TYPE_BLANK_NODE,
            Self::Boolean => ffi::TRACKER_SPARQL_VALUE_TYPE_BOOLEAN,
            Self::__Unknown(value) => value,
        }
    }
}

#[doc(hidden)]
impl FromGlib<ffi::TrackerSparqlValueType> for SparqlValueType {
    #[inline]
    unsafe fn from_glib(value: ffi::TrackerSparqlValueType) -> Self {
        skip_assert_initialized!();

        match value {
            ffi::TRACKER_SPARQL_VALUE_TYPE_UNBOUND => Self::Unbound,
            ffi::TRACKER_SPARQL_VALUE_TYPE_URI => Self::Uri,
            ffi::TRACKER_SPARQL_VALUE_TYPE_STRING => Self::String,
            ffi::TRACKER_SPARQL_VALUE_TYPE_INTEGER => Self::Integer,
            ffi::TRACKER_SPARQL_VALUE_TYPE_DOUBLE => Self::Double,
            ffi::TRACKER_SPARQL_VALUE_TYPE_DATETIME => Self::Datetime,
            ffi::TRACKER_SPARQL_VALUE_TYPE_BLANK_NODE => Self::BlankNode,
            ffi::TRACKER_SPARQL_VALUE_TYPE_BOOLEAN => Self::Boolean,
            value => Self::__Unknown(value),
        }
    }
}
